#include <iostream>
#include <chrono>

using namespace std;

int COUNTER = 0;
string opt = "ACGT";

void permutate(string in_string, int index, int start, int maximum)
{
    for (int i = start; i < opt.length(); ++i) {
        COUNTER++;
        string new_string = in_string.substr(0, index) + opt[i] + in_string.substr(index + 1);

        if (index - 1 >= 0){
            permutate(new_string, 0, 1, index);
        }
    }
    if (index + 1 < maximum){
        permutate(in_string, index + 1, 1, maximum);
    }
}

int main()
{
    auto start = std::chrono::high_resolution_clock::now();

    string init = "AAAAAAAAAAAAA";

    permutate(init, 0, 0, init.length());

    cout << "Number of generated k-mers: " << COUNTER << endl;

    auto stop = std::chrono::high_resolution_clock::now();
    auto duration = std::chrono::duration_cast<std::chrono::milliseconds>(stop - start);
    std::cout << "--- Time consumed: " << duration.count() / 1000. << " seconds ---" << std::endl;

    return 0;
}
