import time

t = time.time()

init = 'AAAAAAAAAAAAA'
opt = "ACGT"

global COUNTER
COUNTER = 0

# alternative way
# def convert(c):
#     if (c == 'A'): return 'C'
#     if (c == 'C'): return 'G'
#     if (c == 'G'): return 'T'
#     if (c == 'T'): return 'A'
# def run(s, s_last, opt, len_str):
#     counter = 1
#     while (s != s_last):
#         counter += 1
#         # You can uncomment the next line to see all k-mers.
#         # print(s)
#         for i in range(len_str):
#             if s[i] == opt[-1]:
#                 s = s[:i] + convert(s[i]) + s[i+1:]
#             else:
#                 s = s[:i] + convert(s[i]) + s[i+1:]
#                 break
#     return counter
#
# counter = run(s, s_last, opt, len_str)


def permutate(in_string, index, start, maximum):
    global COUNTER
    for j in range(start, len(opt)):
        COUNTER += 1
        new_string = in_string[:index] + opt[j] + in_string[index + 1:]

        if index - 1 >= 0:
            permutate(new_string, 0, 1, index)
    else:
        if index + 1 < maximum:
            permutate(in_string, index + 1, 1, maximum)


permutate(init, 0, 0, len(init))


print("Number of generated k-mers: {}".format(COUNTER))
print("--- Time consumed: {} seconds ---".format(time.time() - t))
