import sys

class Demo:
    def __init__(self, t=0):
        self.dim = t
        if (self.dim > 0):
            self.mem = [0.0] * self.dim
        else:
            self.mem = None

        print("konstruktor {}".format(t), file=sys.stderr)

    def __del__(self):
        print("destruktor {}".format(self.dim), file=sys.stderr)
        del self.mem

    def __copy__(self):
        print("kopirovaci konstruktor {}".format(self.dim), file=sys.stderr)
        return Demo(self.dim)

def move(d):
    print("move konstruktor {}".format(d.dim))
    _d = Demo()
    _d.dim = d.dim
    _d.mem = d.mem
    d.dim = 0
    d.mem = None

    return _d
    
