// Autor: Ales Cepek

#include <utility>
#include <iostream>
#include "demo.h"

Demo f(int k=100)
{
  Demo z(k*123);
  // ...
  return std::move(z);
}

using std::cerr;

int main()
{
  cerr << "move konstruktor demo\n\n";
  {
    Demo d0;
    Demo d1(1000);
    Demo d2 = d1;
    Demo d3; d3 = d1;
  }
  cerr << "----------------------\n";
  {
    Demo d4 = Demo(2000);
    Demo d5 = std::move(Demo(3000));
  }
  cerr << "----------------------\n";
  {
    Demo d6 = f();
  }
  cerr << "\n";
}
